<?php

/**
 * Phire System Config File
 *
 * @category   Phire
 * @author     Nick Sagona, III <nick@moc10media.com>
 * @copyright  Copyright (c) 2009-2011 Moc 10 Media, LLC. (http://www.moc10media.com)
 * @license    http://www.phirecms.org/LICENSE.TXT     New BSD License
 * @version    1.1.2
 */

/**
 * Database Configuration Settings
 */

// Define the database interface type, either 'MySQLi' or 'MySQL'.
define('DB_INTERFACE', '');

// Define the database name.
define('DB_NAME', '');

// Define the database user.
define('DB_USER', '');

// Define the database password.
define('DB_PASSWORD', '');

// Define the database host.
define('DB_HOST', '');

// Define the database prefix.
define('DB_PREFIX', '');

/**
 * Site & System Folder Configuration Settings
 */

// Define the overall site & system folder, '/phire-cms-1.1.2'
// by default. Set to null if you want the site and system to
// sit at the top level document root of the domain.
define('BASE_PATH', '/phire-cms-1.1.2');

// Define the system folder underneath the BASE_PATH,
// '/phire' by default.
define('SYS_PATH', '/phire');

// Define the content folder underneath the BASE_PATH,
// '/phire-content' by default.
define('CONTENT_PATH', '/phire-content');

/**
 * Database & Performance Optimization
 *
 * You can turn the following settings to 'Off' to reduce
 * or eliminate the initial load on the database. This, in
 * conjunction with turning on page caching, should improve
 * over system performance (assuming the pages have purely
 * static content, and little to none dynamic content, such
 * as sections or feeds.)
 */

// Define database verifcation, 'On' by default.
define('DB_VERIFY', 'On');

// Define site tracking, 'On' by default.
define('SITE_TRACKING', 'On');

// System language for the Moc10 PHP Library.
define('MOC10_LANG', 'en');

?>