<?php

/**
 * Phire Add Page
 *
 * @category   Phire
 * @author     Nick Sagona, III <nick@moc10media.com>
 * @copyright  Copyright (c) 2009-2011 Moc 10 Media, LLC. (http://www.moc10media.com)
 * @license    http://www.phirecms.org/LICENSE.TXT     New BSD License
 * @version    1.1.2
 */

require_once '../../bootstrap.php';

try {

    // Retrieve session and check if the add page action has been cancelled, clearing out any related session data.
    $sess = Moc10_Session::getInstance();

    if ((isset($_GET['action'])) && ($_GET['action'] == 'cancel')) {

        unset($sess->add_page_form);

        if (isset($_GET['plugin'])) {
            header('Location: ' . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $_GET['plugin'] . '/?sys_path=' . BASE_PATH . SYS_PATH);
        } else {
            header('Location: ' . BASE_PATH . SYS_PATH . '/' . ((isset($_GET['mobile'])) ? 'mobile/' : '') . 'content/pages.php');
        }

    // Else, get the POST data and validate the form.
    } else {
        unset($sess->add_page_form);

        $form = new Phire_Form_Page(BASE_PATH . SYS_PATH . '/core/process/add.page.php', 'post', '        ');
        $form->init($_POST);

        // If the form is valid, process the new page.
        if ($form->isValid()) {

            unset($sess->add_page_form);

            $form->saveData();

            // Return to the edit page page.
            if ((isset($_POST['cont_edit'])) && ($_POST['cont_edit'] == 'Yes')) {
                if ((isset($_POST['plugin'])) && (!is_null($_POST['plugin']))) {
                    header('Location: ' . BASE_PATH . SYS_PATH . '/content/edit-page.php?pid=' . $form->page->page_id . '&action=saved&plugin=' . $_POST['plugin']);
                } else {
                    header('Location: ' . BASE_PATH . SYS_PATH . '/' . ((isset($_POST['mobile'])) ? 'mobile/' : '') . 'content/edit-page.php?pid=' . $form->page->page_id . '&action=saved');
                }
            // Else, return.
            } else {
                if ((isset($_POST['plugin'])) && (!is_null($_POST['plugin']))) {
                    header('Location: ' . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $_POST['plugin'] .'/?action=saved&sys_path=' . BASE_PATH . SYS_PATH);
                } else {
                    $pages = new Phire_Table_Pages();
                    $pages->findAll();

                    $cfg = new Phire_Table_Config();
                    $result = count($pages->rows) / $cfg->settings['system_pagination_limit'];
                    $goToPage = ($result > 1) ? '&page=' . ceil($result) : null;
                    header('Location: ' . BASE_PATH . SYS_PATH . '/' . ((isset($_POST['mobile'])) ? 'mobile/' : '') . 'content/pages.php?action=saved' . $goToPage);
                }
            }

        // Else, set the form into a session variable and return.
        } else {

            $sess->add_page_form = $form;
            header('Location: ' . BASE_PATH . SYS_PATH . '/' . ((isset($_POST['mobile'])) ? 'mobile/' : '') . 'content/add-page.php');

        }

    }

// Else throw a exception/error.
} catch (Exception $e) {

    include_once 'init.php';
    include_once '../includes/error.header.php';
    print("        <p style=\"width: 95%; margin: 0 auto; padding: 5px 0 0 0;\">" . $e->getMessage() . "</p>\n");
    include_once '../includes/footer.php';

}

?>
