<?php

/**
 * Phire Check Page URL
 *
 * @category   Phire
 * @author     Nick Sagona, III <nick@moc10media.com>
 * @copyright  Copyright (c) 2009-2011 Moc 10 Media, LLC. (http://www.moc10media.com)
 * @license    http://www.phirecms.org/LICENSE.TXT     New BSD License
 * @version    1.1.2
 */

require_once '../../bootstrap.php';

// Check for a duplicate URL in the system.
if (isset($_GET['url'])) {

    $error = '';
    $sect_url = '';

    if ($_GET['current'] != '') {

        $page = new Phire_Table_Pages();
        $page->execute("SELECT * FROM " . DB_PREFIX . "pages WHERE page_url = '" . (string)Moc10_String::setString($_GET['url'])->escape()->striptags() . "' AND site_id = '" . (string)Moc10_String::setString($_GET['site_id'])->escape(true)->striptags() . "' LIMIT 1");

        $section = new Phire_Table_Sections();
        $section->execute("SELECT * FROM " . DB_PREFIX . "sections WHERE section_url = '" . (string)Moc10_String::setString($_GET['url'])->escape()->striptags() . "' AND site_id = '" . (string)Moc10_String::setString($_GET['site_id'])->escape(true)->striptags() . "' LIMIT 1");

        if (isset($page->rows[0]) && ($page->rows[0]['page_url'] != '/') && ($page->rows[0]['page_url'] != $_GET['current'])) {
            $error = "<em class=\"error\" style=\"margin: 0; padding: 5px 0;\">" . $lang->__('That URL already exists in the system for that site. Please choose another URL.') . "</em>";
        } else if (isset($section->rows[0])) {
            $error = "<em class=\"error\" style=\"margin: 0; padding: 5px 0;\">" . $lang->__('That URL already exists in the system for that site. Please choose another URL.') . "</em>";
        } else if ((substr($_GET['url'], 0, strlen(BASE_PATH . SYS_PATH)) == BASE_PATH . SYS_PATH) || (substr($_GET['url'], 0, 7) == '/search') || (substr($_GET['url'], 0, 4) == '/feed') || (substr($_GET['url'], 0, 5) == '/user') || (substr($_GET['url'], 0, 7) == '/member') || (substr($_GET['url'], 0, 4) == '/tag') || (substr($_GET['url'], 0, 8) == '/captcha')) {
            $error = "<em class=\"error\" style=\"margin: 0; padding: 5px 0;\">" . $lang->__('That URL is a reserved system URL. Please choose another URL.') . "</em>";
        } else {
            $error = '';
        }

    } else {

        $page = new Phire_Table_Pages();
        $page->execute("SELECT * FROM " . DB_PREFIX . "pages WHERE page_url = '" . (string)Moc10_String::setString($_GET['url'])->escape()->striptags() . "' AND site_id = '" . (string)Moc10_String::setString($_GET['site_id'])->escape(true)->striptags() . "' LIMIT 1");

        $section = new Phire_Table_Sections();
        $section->execute("SELECT * FROM " . DB_PREFIX . "sections WHERE section_url = '" . (string)Moc10_String::setString($_GET['url'])->escape()->striptags() . "' AND site_id = '" . (string)Moc10_String::setString($_GET['site_id'])->escape(true)->striptags() . "' LIMIT 1");

        if (isset($page->rows[0]) && ($page->rows[0]['page_url'] != '/')) {
            $error = "<em class=\"error\" style=\"margin: 0; padding: 5px 0;\">" . $lang->__('1That URL already exists in the system for that site. Please choose another URL.') . "</em>";
        } else if (isset($section->rows[0])) {
            $error = "<em class=\"error\" style=\"margin: 0; padding: 5px 0;\">" . $lang->__('That URL already exists in the system for that site. Please choose another URL.') . "</em>";
        } else if ((substr($_GET['url'], 0, strlen(BASE_PATH . SYS_PATH)) == BASE_PATH . SYS_PATH) || (substr($_GET['url'], 0, 7) == '/search') || (substr($_GET['url'], 0, 4) == '/feed') || (substr($_GET['url'], 0, 5) == '/user') || (substr($_GET['url'], 0, 7) == '/member') || (substr($_GET['url'], 0, 4) == '/tag') || (substr($_GET['url'], 0, 8) == '/captcha')) {
            $error = "<em class=\"error\" style=\"margin: 0; padding: 5px 0;\">" . $lang->__('That URL is a reserved system URL. Please choose another URL.') . "</em>";
        } else {
            $error = '';
        }

    }

    if ($_GET['section_id'] != 0) {
        $section = new Phire_Table_Sections();
        $section->findById($_GET['section_id']);

        if (isset($section->section_id)) {
            $sect_url = $section->section_url;
        }
    }

    print("var urlReturn = new Array('" . $error . "', '" . $sect_url . "');");

}


?>
