<?php

/**
 * Phire Copy Feed
 *
 * @category   Phire
 * @author     Nick Sagona, III <nick@moc10media.com>
 * @copyright  Copyright (c) 2009-2011 Moc 10 Media, LLC. (http://www.moc10media.com)
 * @license    http://www.phirecms.org/LICENSE.TXT     New BSD License
 * @version    1.1.2
 */

require_once '../../bootstrap.php';

try {

    // If the correct variable is passed, find the feed.
    if (isset($_GET['fid'])) {

        $feed = new Phire_Table_Feeds();
        $feed->findById($_GET['fid']);

        // If the feed is found, duplicate the feed entry.
        if (isset($feed->feed_id)) {

            // Check for feed name duplicates.
            $i = 0;
            $org_feed_title = $feed->feed_title;
            $feed_title_copy = $org_feed_title . ' (Copy)';

            $test_feed = new Phire_Table_Feeds();
            $test_feed->findBy('feed_title', $feed_title_copy);

            while (isset($test_feed->feed_id)) {
                $i++;
                $feed_title_copy = $org_feed_title  . ' (Copy ' . $i . ')';
                $test_feed = new Phire_Table_Feeds();
                $test_feed->findBy('feed_title', $feed_title_copy);
            }

            // Once a new unique feed name is confirmed, set the fields and save the copy of the feed.
            $fields = array('site_id' => $feed->site_id,
                            'feed_title' => $feed_title_copy,
                            'feed_url' => $feed->feed_url,
                            'feed_template' => $feed->feed_template,
                            'list_limit' => $feed->list_limit);

            $feedcopy = new Phire_Table_Feeds($fields);
            $feedcopy->save();

        }

    }

    if (isset($_GET['mobile'])) {
        header('Location: ' . BASE_PATH . SYS_PATH . '/mobile/content/feeds.php');
    } else {
        header('Location: ' . BASE_PATH . SYS_PATH . '/content/feeds.php');
    }

// Else throw a exception/error.
} catch (Exception $e) {

    include_once 'init.php';
    include_once '../includes/error.header.php';
    print("        <p style=\"width: 95%; margin: 0 auto; padding: 5px 0 0 0;\">" . $e->getMessage() . "</p>\n");
    include_once '../includes/footer.php';

}

?>
