<?php

/**
 * Phire Download Plugins
 *
 * @category   Phire
 * @author     Nick Sagona, III <nick@moc10media.com>
 * @copyright  Copyright (c) 2009-2011 Moc 10 Media, LLC. (http://www.moc10media.com)
 * @license    http://www.phirecms.org/LICENSE.TXT     New BSD License
 * @version    1.1.2
 */

require_once '../../bootstrap.php';

try {

    // Get the plugins to download.
    $dload_plugins = array();

    if (isset($_POST['dload_plugins'][0])) {

        foreach ($_POST['dload_plugins'] as $value) {
            $dload_plugins[] = array('id' => $value, 'file' => $_POST['file_' . $value]);
        }

        $site = new Phire_Table_Sites();
        $site->findById($_POST['site_id']);

        // Download each selected plugin via cURL to the server.
        foreach ($dload_plugins as $ary) {

            $options = array(CURLOPT_URL => 'http://' . $_POST['baseurl'] . '/extensions/plugins/get-plugin.php?pid=' . $ary['id'],
                             CURLOPT_HEADER => FALSE,
                             CURLOPT_RETURNTRANSFER => TRUE);

            $curl = new Moc10_Curl($options);
            $output = $curl->execute();

            // If the plugin file successfully downloaded, store it in the plugins folder.
            if (strlen($output) > 0) {
                $plugin_file = new Moc10_File($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $ary['file']);
                $plugin_file->write($output);
                $plugin_file->setMode(0777);
            }

            unset($curl);

        }

        header('Location: ' . BASE_PATH . SYS_PATH . '/extensions/plugins.php?action=downloaded');

    } else {

        header('Location: ' . BASE_PATH . SYS_PATH . '/extensions/download-plugins.php');

    }

// Else throw a exception/error.
} catch (Exception $e) {

    include_once 'init.php';
    include_once '../includes/error.header.php';
    print("        <p style=\"width: 95%; margin: 0 auto; padding: 5px 0 0 0;\">" . $e->getMessage() . "</p>\n");
    include_once '../includes/footer.php';

}

?>
