<?php

/**
 * Phire Edit User
 *
 * @category   Phire
 * @author     Nick Sagona, III <nick@moc10media.com>
 * @copyright  Copyright (c) 2009-2011 Moc 10 Media, LLC. (http://www.moc10media.com)
 * @license    http://www.phirecms.org/LICENSE.TXT     New BSD License
 * @version    1.1.2
 */

require_once '../../bootstrap.php';

try {

    // Retrieve session and check if the edit account action has been cancelled, clearing out any related session data.
    $sess = Moc10_Session::getInstance();

    if ((isset($_GET['action'])) && ($_GET['action'] == 'cancel')) {

        unset($sess->edit_acct_form);

        if (isset($_GET['plugin'])) {
            header('Location: ' . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $_GET['plugin'] . '/?sys_path=' . BASE_PATH . SYS_PATH);
        } else {
            header('Location: ' . BASE_PATH . SYS_PATH . '/');
        }

    // Else, get the POST data and validate the form.
    } else {

        $uid = (string)Moc10_String::setString($_POST['user_id'])->escape(true)->striptags();

        // If the user account has been selected to be closed, update any related assets and delete the user account.
        if (isset($_POST['close_acct'][0])) {

            $sessions = new Phire_Table_Sessions();
            $sessions->execute("DELETE FROM " . DB_PREFIX . "sessions WHERE user_id = '" . $uid . "'");

            $pages = new Phire_Table_Pages();
            $pages->execute("UPDATE " . DB_PREFIX . "pages SET user_id = 0 WHERE user_id = '" . $uid . "'");

            $files = new Phire_Table_Files();
            $files->execute("UPDATE " . DB_PREFIX . "files SET user_id = 0 WHERE user_id = '" . $uid . "'");

            $images = new Phire_Table_Images();
            $images->execute("UPDATE " . DB_PREFIX . "images SET user_id = 0 WHERE user_id = '" . $uid . "'");

            $comments = new Phire_Table_Comments();
            $comments->execute("UPDATE " . DB_PREFIX . "comments SET user_id = 0, comment_author = 'Anonymous' WHERE user_id = '" . $uid . "'");

            $user = new Phire_Table_Users();
            $user->findById($uid);
            $user->delete();

            $sess->kill();
            header('Location: ' . BASE_PATH . SYS_PATH . '/login.php?logout=closed');

        // Else, validate and process the form.
        } else {

            unset($sess->edit_acct_form);

            $form = new Phire_Form_EditAccount(BASE_PATH . SYS_PATH . '/core/process/edit.account.php?uid=' . $uid, 'post', '        ');
            $form->init($_POST);

            // If the form is valid, process the user account data.
            if ($form->isValid()) {

                unset($sess->edit_acct_form);

                $form->saveData();

                // Return.
                if ((isset($_POST['plugin'])) && (!is_null($_POST['plugin']))) {
                    header('Location: ' . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $_POST['plugin'] .'/?action=saved&sys_path=' . BASE_PATH . SYS_PATH);
                } else {
                    header('Location: ' . BASE_PATH . SYS_PATH . '/system/edit-account.php?uid=' . $uid . '&action=saved');
                }

            // Else, set the form into a session variable and return.
            } else {
                $sess->edit_acct_form = $form;
                header('Location: ' . BASE_PATH . SYS_PATH . '/system/edit-account.php?uid=' . $uid);
            }

        }

    }

// Else throw a exception/error.
} catch (Exception $e) {

    include_once 'init.php';
    include_once '../includes/error.header.php';
    print("        <p style=\"width: 95%; margin: 0 auto; padding: 5px 0 0 0;\">" . $e->getMessage() . "</p>\n");
    include_once '../includes/footer.php';

}

?>
