<?php

/**
 * Phire Get Plugins
 *
 * @category   Phire
 * @author     Nick Sagona, III <nick@moc10media.com>
 * @copyright  Copyright (c) 2009-2011 Moc 10 Media, LLC. (http://www.moc10media.com)
 * @license    http://www.phirecms.org/LICENSE.TXT     New BSD License
 * @version    1.1.2
 */

require_once dirname(__FILE__) . '/config.check.php';

$dload = $lang->__('Download Plugins');
$plgn = $lang->__('Plugin');
$ste = $lang->__('Site');
$click = $lang->__('Click to Manage');
$tabs = $lang->__('# of DB Tables');
$fldrs = $lang->__('# of Subfolders');
$vrsn = $lang->__('Version');
$auth = $lang->__('Author');
$desc = $lang->__('Description');
$remove = $lang->__('Remove?');
$remove_btn = $lang->__('Remove');

$int_sort_id = 'plugin_id';
$tableHeader = "<tr><td class=\"grayHeader\" style=\"width: 7%; text-align: center;\"><a class=\"grayLink\" href=\"./plugins.php?sort=plugin_id\">ID #</a></td><td class=\"grayHeader\" style=\"width: 20%; text-align: left;\"><a class=\"grayLink\" href=\"./plugins.php?sort=plugin_name\">{$plgn}</a> ({$click})</td><td class=\"grayHeader\" style=\"padding: 0; text-align: left;\"><a class=\"grayLink\" href=\"./plugins.php?sort=site_id\">{$ste}</a></td><td class=\"grayHeader\" style=\"padding: 0; text-align: center;\"><strong>{$tabs}</strong></td><td class=\"grayHeader\" style=\"padding: 0; text-align: center;\"><strong>{$fldrs}</strong></td><td class=\"grayHeader\" style=\"width: 7%; padding: 0; text-align: center;\"><strong>{$vrsn}</strong></td><td class=\"grayHeader\" style=\"padding: 0; text-align: left;\"><strong>{$auth}</strong></td><td class=\"grayHeader\" style=\"width: 25%; padding: 0; text-align: left;\"><strong>{$desc}</strong></td><td class=\"grayHeader\" style=\"padding: 0; width: 7%; text-align: center;\"><strong>{$remove}</strong></td></tr>";
$dir2Chk = './plugins';
require_once '../core/process/calculate.sort.php';
require_once '../core/process/check.plugins.php';

try {

    if (count($newPlugins) > 0) {
        $installPlugins = " <span class=\"grayPad\">|</span> " . $lang->__('New plugins have been detected. %1Click here%2 to install.', array("<a class=\"orangeLink\" href=\"../core/process/install.plugins.php\">", "</a>"));
    } else {
        $installPlugins = "";
    }

    $plugins = new Phire_Table_Plugins();

    // Get user's allowed sites.
    if (isset($sess->sites)) {

        $site_ids = array();
        foreach ($sess->sites as $value) {
            $site_ids[] = "site_id = '" . $value . "'";
        }
        $sql = "SELECT * FROM " . DB_PREFIX . "plugins WHERE " . implode(' OR ', $site_ids) . " ORDER BY " . $sort;

        $plugins->execute($sql);

    }

    if (isset($plugins->rows[0])) {

        // Print the table header.
        print <<<TABLEHEADER
        <form id="pluginsForm" action="./plugins.php" method="post" onsubmit="return pluginsFrm.checkValidate('plugin', true);">
            <table id="headerTable" cellpadding="0" cellspacing="0"><tr><td><input style="margin: 0 3% 0 0; float: right;" type="checkbox" class="checkBox" id="check_all" name="check_all" value="all" onclick="formCheckAll(this, pluginsFrm, 'rm_plugins');" /><a class="orangeLink" href="./download-plugins.php">{$dload}</a>{$installPlugins}</td></tr></table>
            <table id="dataTable" cellpadding="0" cellspacing="0">
                {$tableHeader}

TABLEHEADER;

        $id = null;

        foreach ($plugins->rows as $plugin) {

            $plugin_name = Moc10_String::setString($plugin->plugin_name)->strip()->html();

            $site = new Phire_Table_Sites();
            $site->findById($plugin->site_id);

            if ($plugin->plugin_tables != '') {
                $numAry = explode('|', $plugin->plugin_tables);
            } else {
                $numAry = array();
            }

            if ($plugin->plugin_subfolders != '') {
                $subAry = explode('|', $plugin->plugin_subfolders);
            } else {
                $subAry = array();
            }

            $plugin_link = (file_exists($_SERVER['DOCUMENT_ROOT'] . BASE_PATH . CONTENT_PATH . "/extensions/plugins/{$plugin->plugin_folder}/index.php")) ? "<a href=\"" . BASE_PATH . CONTENT_PATH . "/extensions/plugins/{$plugin->plugin_folder}/?sys_path=" . BASE_PATH . SYS_PATH . "\">{$plugin_name}</a>" : "<strong>{$plugin_name}</strong>";

            print("                <tr><td style=\"text-align: center;\">{$plugin->plugin_id}</td><td style=\"text-align: left;\">{$plugin_link}</td><td>{$site->site_domain}</td><td style=\"text-align: center;\">" . count($numAry) . "</td><td style=\"text-align: center;\">" . count($subAry) . "</td><td style=\"text-align: center;\">{$plugin->plugin_version}</td><td>{$plugin->plugin_author}</td><td>{$plugin->plugin_desc}</td><td style=\"text-align: center;\"><input type=\"checkbox\" class=\"checkBox\" id=\"rm_plugins{$id}\" name=\"rm_plugins[]\" value=\"{$plugin->plugin_id}\" /></td></tr>\n");
            $id++;

        }

        // Print the table footer.
        print <<<TABLEFOOTER
            </table>
            <table id="footerTable" cellpadding="0" cellspacing="0"><tr><td><input style="float: right;" type="submit" class="submitRedBtn" value="{$remove_btn}" /></td></tr></table>
        </form>
        <script type="text/javascript">
            pluginsFormInit();
        </script>

TABLEFOOTER;

    // Else, print a no results table.
    } else {

        $noplugins = $lang->__('There are currently no plugins.');

        print <<<TABLEHEADER
        <table id="headerTable" cellpadding="0" cellspacing="0"><tr><td><a class="orangeLink" href="./download-plugins.php">{$dload}</a>{$installPlugins}</td></tr></table>
        <table id="dataTable" cellpadding="0" cellspacing="0">
            {$tableHeader}
            <tr><td colspan="9" style="padding: 25px;">{$noplugins}</td></tr>
        </table>

TABLEHEADER;

    }

// Else throw a exception/error.
} catch (Exception $e) {

    print("        <p style=\"width: 95%; margin: 0 auto; padding: 5px 0 10px 0;\">" . $e->getMessage() . "</p>\n");

}

?>
