<?php

/**
 * Phire Mobile Get Event Types
 *
 * @category   Phire
 * @author     Nick Sagona, III <nick@moc10media.com>
 * @copyright  Copyright (c) 2009-2011 Moc 10 Media, LLC. (http://www.moc10media.com)
 * @license    http://www.phirecms.org/LICENSE.TXT     New BSD License
 * @version    1.1.2
 */

require_once dirname(__FILE__) . '/../config.check.php';

$back = $lang->__('Back to Events');
$typ = $lang->__('Event Type');
$remove = $lang->__('Remove?');
$add = $lang->__('Add');
$update = strtoupper($lang->__('Update'));

$int_sort_id = 'type_id';
require_once '../../core/process/calculate.sort.php';

try {

    // Get the event types.
    $types = new Phire_Table_EventTypes();
    $types->findAll($sort);

    // Print the table header.
    print <<<TABLEHEADER
        <form id="typesForm" action="../../core/process/update.event.types.php" method="post">
            <table id="headerTable" cellpadding="0" cellspacing="0"><tr><td>&lt;&lt;&lt; <a class="orangeLink" href="./events.php"> {$back}</a></td></tr></table>
            <table id="dataTable" cellpadding="0" cellspacing="0">
                <tr><td class="grayHeader" style="width: 20%; padding: 0; text-align: center;"><a class="grayLink" href="./edit-event-types.php?sort=type_id">ID #</a></td><td class="grayHeader" style="text-align: left;"><a class="grayLink" href="./edit-event-types.php?sort=event_type">{$typ}</a></td><td class="grayHeader" style="padding: 0; width: 25%; text-align: center;"><strong>{$remove}</strong></td></tr>

TABLEHEADER;

    // Iterate throught the event types.
    if (isset($types->rows[0])) {
        foreach ($types->rows as $typ) {
            print("                <tr><td style=\"padding: 5px 0 5px 0; text-align: center;\">{$typ->type_id}</td><td style=\"padding: 5px 0 5px 0; text-align: left;\"><input style=\"font-size: 1.0em;\" type=\"text\" name=\"type_event_{$typ->type_id}\" value=\"" . Moc10_String::setString($typ->event_type)->strip()->html() . "\" size=\"25\" /></td><td style=\"text-align: center;\"><input type=\"checkbox\" class=\"checkBox\" name=\"rm_types[]\" value=\"{$typ->type_id}\" /></td></tr>\n");
        }
    // Else, print no result.
    } else {
        print("            <tr><td colspan=\"3\" style=\"padding: 25px;\">" . $lang->__('There are currently no event types.') . "</td></tr>\n");
    }

    // Print the table footer.
    print <<<TABLEFOOTER
                <tr style="margin: 0; padding: 5px 0 5px 10px;"><td style="padding: 5px 0 5px 0; text-align: center;"><strong>{$add} [+]</strong></td><td style="padding: 5px 0 5px 0;"><input style="font-size: 1.0em;" type="text" name="type_new" value="" size="25" /></td><td style="text-align: center;">&nbsp;</td></tr>
            </table>
            <table id="footerTable" cellpadding="0" cellspacing="0"><tr><td><input style="float: right;" type="submit" class="submitBtn" value="{$update}" /><input type="hidden" name="mobile" value="true" /></td></tr></table>
        </form>

TABLEFOOTER;

// Else throw a exception/error.
} catch (Exception $e) {

    print("        <p style=\"width: 95%; margin: 0 auto; padding: 5px 0 10px 0;\">" . $e->getMessage() . "</p>\n");

}

?>
