<?php

/**
 * Phire Re-Import Themes
 *
 * @category   Phire
 * @author     Nick Sagona, III <nick@moc10media.com>
 * @copyright  Copyright (c) 2009-2011 Moc 10 Media, LLC. (http://www.moc10media.com)
 * @license    http://www.phirecms.org/LICENSE.TXT     New BSD License
 * @version    1.1.2
 */

require_once '../../bootstrap.php';

if (!isset($_GET['tid'])) {
    header('Location: ' . BASE_PATH . SYS_PATH . '/extensions/themes.php');
} else {
    $theme = new Phire_Table_Themes();
    $theme->findById($_GET['tid']);
    if (!isset($theme->theme_id)) {
        header('Location: ' . BASE_PATH . SYS_PATH . '/extensions/themes.php');
    } else {

        $site = new Phire_Table_Sites();
        $site->findById($theme->site_id);

        if (file_exists($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/themes/' . $theme->theme_folder . '/' . $theme->theme_folder . '.txt')) {
            $txtFile = new Moc10_File($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/themes/' . $theme->theme_folder . '/' . $theme->theme_folder . '.txt');
            $output = $txtFile->read();

            $tmpls = substr($output, (strpos($output, '*/') + 6));

            $tmplAry = explode("\n", $tmpls);
            $templates = array();
            $tmplIds = array();

            if (count($tmplAry) > 0) {
                foreach ($tmplAry as $value) {
                    $templates[] = explode(':', $value);
                }
            }

            // Iterate through each template in the theme.
            foreach ($templates as $tmpl) {
                // Check for an existing template.
                $template_name = trim($tmpl[0]);
                $tmp = new Phire_Table_Templates();
                $tmp->findBy('template_name', $template_name);

                if (trim($tmpl[1]) != '') {
                    // Prep the template file.
                    $new_template = new Moc10_File($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/themes/' . $theme->theme_folder . '/' . trim($tmpl[1]));
                    if (isset($tmpl[2])) {
                        $new_mobile_template = new Moc10_File($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/themes/' . $theme->theme_folder . '/' . trim($tmpl[2]));
                        $mob_tmpl = $new_mobile_template->read();
                    } else {
                        $mob_tmpl = '';
                    }

                    $contentType = new Phire_Table_ContentTypes();
                    $contentType->findBy('type', $new_template->mime);

                    // If the template exists already, re-import it.
                    if (isset($tmp->template_id)) {
                        $tmp->type_id = ((isset($contentType->type_id)) ? $contentType->type_id : 3001);
                        $tmp->template = $new_template->read();
                        $tmp->mobile_template = $mob_tmpl;
                        $tmp->save();
                    // Else, add it as a new template.
                    } else {
                        $tmp = new Phire_Table_Templates(Array('site_id' => $theme->site_id,
                                                                 'theme_id' => $theme->theme_id,
                                                                 'type_id' => ((isset($contentType->type_id)) ? $contentType->type_id : 3001),
                                                                 'template_name' => $template_name,
                                                                 'template' => $new_template->read(),
                                                                 'mobile_template' => $mob_tmpl));
                        $tmp->save();
                        if (strpos($theme->templates, $tmp->template_id) === false) {
                            $tmp_ids = explode('|', $theme->templates);
                            $tmp_ids[] = $tmp->template_id;
                            $theme->templates = implode('|', $tmp_ids);
                            $theme->save();
                        }
                    }
                }
            }

        }

        header('Location: ' . BASE_PATH . SYS_PATH . '/extensions/themes.php?action=saved');

    }

}

?>