<?php

/**
 * Phire Remove Sites
 *
 * @category   Phire
 * @author     Nick Sagona, III <nick@moc10media.com>
 * @copyright  Copyright (c) 2009-2011 Moc 10 Media, LLC. (http://www.moc10media.com)
 * @license    http://www.phirecms.org/LICENSE.TXT     New BSD License
 * @version    1.1.2
 */

require_once '../../bootstrap.php';

try {

    // Get the sites to remove.
    $rm_sites = array();
    $rm_sites = $_POST['rm_sites'];

    if (isset($rm_sites[0])) {

        foreach ($rm_sites as $value) {

            $val = (string)Moc10_String::setString($value)->escape(true)->striptags();

            // Get the site.
            $site = new Phire_Table_Sites();
            $site->findById($value);

            // Remove the site from any users allowed_sites field.
            $users = new Phire_Table_Users();
            $users->search(array('allowed_sites' => '%' . $val . '%'));
            if (isset($users->rows[0])) {
                foreach ($users->rows as $vl) {
                    $allowed_sites = array();
                    $allowed_sites = explode('|', $vl['allowed_sites']);
                    if (in_array($val, $allowed_sites)) {
                        $key = array_search($val, $allowed_sites);
                        unset($allowed_sites[$key]);
                    }
                    $user = new Phire_Table_Users();
                    $user->findById($vl['user_id']);
                    $user->allowed_sites = implode('|', $allowed_sites);
                    $user->save();
                }
            }

            // Remove all templates related to the site.
            $tmpls = new Phire_Table_Templates();
            $tmpls->execute("DELETE FROM " . DB_PREFIX . "templates WHERE site_id = '" . $val . "'");

            // Remove all themes related to the site.
            $themes = new Phire_Table_Themes();
            $themes->execute("SELECT * FROM " . DB_PREFIX . "themes WHERE site_id = '" . $val . "'");

            if (isset($themes->rows[0])) {

                foreach ($themes->rows as $thm) {
                    $theme = new Phire_Table_Themes();
                    $theme->findById($thm->theme_id);

                    // Remove the theme file.
                    if (($theme->theme_file != '') && (file_exists($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/themes/' . $theme->theme_file))) {
                        unlink($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/themes/' . $theme->theme_file);
                    }

                    // Clean out and remove any theme files and folders.
                    if (file_exists($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/themes/' . $theme->theme_folder) && is_dir($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/themes/' . $theme->theme_folder)) {
                        $dir = new Moc10_File_Dir($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/themes/' . $theme->theme_folder, true, true);

                        foreach ($dir->files as $fle) {
                            if ((file_exists($fle)) && (is_file($fle))) {
                                unlink($fle);
                            }
                        }

                        foreach ($dir->files as $fle) {
                            if ((file_exists($fle)) && (is_dir($fle))) {
                                rmdir($fle);
                            }
                        }
                        $dir->emptyDir($dir->path);
                    }

                    // Remove the theme folder.
                    if (file_exists($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/themes/' . $theme->theme_folder) && is_dir($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/themes/' . $theme->theme_folder)) {
                        rmdir($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/themes/' . $theme->theme_folder);
                    }

                    $theme->delete();

                }

            }

            // Get the system docroot.
            $sysdocroot = new Phire_Table_Config();
            $sysdocroot->findById('system_docroot');

            // Remove all plugins related to the site.
            $plugins = new Phire_Table_Plugins();
            $plugins->execute("SELECT * FROM " . DB_PREFIX . "plugins WHERE site_id = '" . $val . "'");

            if (isset($plugins->rows[0])) {

                foreach ($plugins->rows as $plg) {
                    $plugin = new Phire_Table_Plugins();
                    $plugin->findById($plg->plugin_id);

                    // Retrieve and drop any plugin DB tables.
                    $tableAry = array();
                    $tableAry = explode('|', $plugin->plugin_tables);

                    if (count($tableAry) > 0) {
                        $db = Moc10_Db::getInstance();
                        foreach ($tableAry as $tab) {
                            $db->interface->query('DROP TABLE ' . $tab);
                        }
                    }

                    // Remove the plugin file under the site root.
                    if (($plugin->plugin_file != '') && (file_exists($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $plugin->plugin_file))) {
                        unlink($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $plugin->plugin_file);
                    }

                    // Remove the plugin file under the system root.
                    if (($plugin->plugin_file != '') && (file_exists($sysdocroot->value . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $plugin->plugin_file))) {
                        unlink($sysdocroot->value . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $plugin->plugin_file);
                    }

                    // Clean out and remove any plugin files and folders under the site root.
                    if (file_exists($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $plugin->plugin_folder) && is_dir($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $plugin->plugin_folder)) {
                        $dir = new Moc10_File_Dir($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $plugin->plugin_folder, true, true);
                        foreach ($dir->files as $fle) {
                            if ((file_exists($fle)) && (is_file($fle))) {
                                unlink($fle);
                            }
                        }

                        foreach ($dir->files as $fle) {
                            if ((file_exists($fle)) && (is_dir($fle))) {
                                rmdir($fle);
                            }
                        }
                        $dir->emptyDir($dir->path);
                    }

                    // Clean out and remove any plugin files and folders under the system root.
                    if (file_exists($sysdocroot->value . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $plugin->plugin_folder) && is_dir($sysdocroot->value . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $plugin->plugin_folder)) {
                        $sysdir = new Moc10_File_Dir($sysdocroot->value . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $plugin->plugin_folder, true, true);
                        foreach ($sysdir->files as $fle) {
                            if ((file_exists($fle)) && (is_file($fle))) {
                                unlink($fle);
                            }
                        }

                        foreach ($sysdir->files as $fle) {
                            if ((file_exists($fle)) && (is_dir($fle))) {
                                rmdir($fle);
                            }
                        }
                        $sysdir->emptyDir($sysdir->path);
                    }

                    // Remove the plugin folder under the site root.
                    if (file_exists($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $plugin->plugin_folder) && is_dir($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $plugin->plugin_folder)) {
                        rmdir($site->site_docroot . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $plugin->plugin_folder);
                    }
                    // Remove the plugin folder under the system root.
                    if (file_exists($sysdocroot->value . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $plugin->plugin_folder) && is_dir($sysdocroot->value . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $plugin->plugin_folder)) {
                        rmdir($sysdocroot->value . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $plugin->plugin_folder);
                    }

                    // Remove the plugin.
                    $plugin->delete();

                }

            }

            // Remove all members related to the site.
            $members = new Phire_Table_Members();
            $members->execute("DELETE FROM " . DB_PREFIX . "members WHERE site_id = '" . $val . "'");

            // Remove all sections related to the site.
            $sects = new Phire_Table_Sections();
            $sects->findAll(null, 'site_id', $val);

            if (isset($sects->rows[0])) {
                foreach ($sects->rows as $val) {
                    $sid = $val['section_id'];

                    // Remove all files related to the section.
                    $files = new Phire_Table_Files();
                    $files->findAll(null, 'section_id', $sid);
                    if (isset($files->rows[0])) {
                        foreach ($files->rows as $v) {
                            $file = new Phire_Table_Files();
                            $file->findById($v['file_id']);
                            if (file_exists($site->site_docroot . BASE_PATH . CONTENT_PATH . '/assets/files/' . $file->file_name)) {
                                unlink($site->site_docroot . BASE_PATH . CONTENT_PATH . '/assets/files/' . $file->file_name);
                            }
                            $file->delete();
                        }
                    }

                    // Remove all images related to the section.
                    $imgs = new Phire_Table_Images();
                    $imgs->findAll(null, 'section_id', $sid);
                    if (isset($imgs->rows[0])) {
                        foreach ($imgs->rows as $v) {
                            $img = new Phire_Table_Images();
                            $img->findById($v['image_id']);
                            if (file_exists($site->site_docroot . BASE_PATH . CONTENT_PATH . '/assets/images/large/' . $img->image_name)) {
                                unlink($site->site_docroot . BASE_PATH . CONTENT_PATH . '/assets/images/large/' . $img->image_name);
                            }
                            if (file_exists($site->site_docroot . BASE_PATH . CONTENT_PATH . '/assets/images/medium/' . $img->image_name)) {
                                unlink($site->site_docroot . BASE_PATH . CONTENT_PATH . '/assets/images/medium/' . $img->image_name);
                            }
                            if (file_exists($site->site_docroot . BASE_PATH . CONTENT_PATH . '/assets/images/small/' . $img->image_name)) {
                                unlink($site->site_docroot . BASE_PATH . CONTENT_PATH . '/assets/images/small/' . $img->image_name);
                            }
                            $img->delete();
                        }
                    }

                    // Remove the section.
                    $sect = new Phire_Table_Sections();
                    $sect->findById($sid);
                    $sect->delete();
                }
            }

            // Remove all files related to the site.
            $files = new Phire_Table_Files();
            $files->execute("SELECT * FROM " . DB_PREFIX . "files WHERE site_id = '" . $val . "'");

            if (isset($files->rows[0])) {
                foreach ($files->rows as $file) {
                    // Remove the file.
                    $fle = new Phire_Table_Files();
                    $fle->findById($file->file_id);
                    if (file_exists($site->site_docroot . BASE_PATH . CONTENT_PATH . '/assets/files/' . $fle->file_name)) {
                        unlink($site->site_docroot . BASE_PATH . CONTENT_PATH . '/assets/files/' . $fle->file_name);
                    }
                    $fle->delete();
                }
            }


            // Remove all images related to the site.
            $images = new Phire_Table_Images();
            $images->execute("SELECT * FROM " . DB_PREFIX . "images WHERE site_id = '" . $val . "'");

            if (isset($images->rows[0])) {
                foreach ($images->rows as $image) {
                    // Remove the image.
                    $img = new Phire_Table_Images();
                    $img->findById($image->image_id);
                    if (file_exists($site->site_docroot . BASE_PATH . CONTENT_PATH . '/assets/images/large/' . $img->image_name)) {
                        unlink($site->site_docroot . BASE_PATH . CONTENT_PATH . '/assets/images/large/' . $img->image_name);
                    }
                    if (file_exists($site->site_docroot . BASE_PATH . CONTENT_PATH . '/assets/images/medium/' . $img->image_name)) {
                        unlink($site->site_docroot . BASE_PATH . CONTENT_PATH . '/assets/images/medium/' . $img->image_name);
                    }
                    if (file_exists($site->site_docroot . BASE_PATH . CONTENT_PATH . '/assets/images/small/' . $img->image_name)) {
                        unlink($site->site_docroot . BASE_PATH . CONTENT_PATH . '/assets/images/small/' . $img->image_name);
                    }
                    $img->delete();
                }
            }

            // Remove all events related to the site.
            $events = new Phire_Table_Events();
            $events->findAll(null, 'site_id', $val);
            if (isset($events->rows[0])) {
                foreach ($events->rows as $vl) {
                    // Remove the event.
                    $event = new Phire_Table_Events();
                    $event->findById($vl['event_id']);
                    $event->delete();
                }
            }

            // Remove all pages related to the site.
            $pages = new Phire_Table_Pages();
            $pages->findAll(null, 'site_id', $val);
            if (isset($pages->rows[0])) {
                foreach ($pages->rows as $vl) {
                    $pid = $vl['page_id'];

                    // Remove all comments related to the page.
                    $cmt = new Phire_Table_Comments();
                    $cmt->execute("DELETE FROM " . DB_PREFIX . "comments WHERE page_id = '" . $pid . "'");

                    // Remove the page.
                    $page = new Phire_Table_Pages();
                    $page->findById($pid);
                    $page->delete();
                }
            }

            // Remove any site cache files.
            $cache_dir = $site->site_docroot . BASE_PATH . CONTENT_PATH . '/cache';
            if (file_exists($cache_dir)) {
                $dir = new Moc10_File_Dir($cache_dir);
                if (isset($dir->files[0])) {
                    foreach ($dir->files as $fle) {
                        if ((stripos($fle, '.txt') !== false) && file_exists($dir->path . '/' . $fle)) {
                            unlink($dir->path . '/' . $fle);
                        }
                    }
                }
            }

            // Remove any site cache mobile files.
            $cache_mob_dir = $site->site_docroot . BASE_PATH . CONTENT_PATH . '/cache/mobile';
            if (file_exists($cache_dir)) {
                $dir = new Moc10_File_Dir($cache_mob_dir);
                if (isset($dir->files[0])) {
                    foreach ($dir->files as $fle) {
                        if ((stripos($fle, '.txt') !== false) && file_exists($dir->path . '/' . $fle)) {
                            unlink($dir->path . '/' . $fle);
                        }
                    }
                }
            }

            $sess = Moc10_Session::getInstance();
            $user = new Phire_Table_Users();
            $user->findById($sess->user_id);

            $sitesAry = array();
            $sitesAry = explode('|', $user->allowed_sites);
            if (array_search($site->site_id, $sitesAry) !== false) {
                $key = array_search($site->site_id, $sitesAry);
                unset($sitesAry[$key]);
            }
            $sess->sites = $sitesAry;
            $user->allowed_sites = implode('|', $sitesAry);
            $user->save();

            if (array_key_exists($val, $sess->open_authoring)) {
                $ary = $sess->open_authoring;
                unset($ary[$val]);
                $sess->open_authoring = $ary;
            }

            // Remove any site 404s.
            $site404s = new Phire_Table_404s();
            $site404s->execute("DELETE FROM " . DB_PREFIX . "404s WHERE site_id = '" . $site->site_id . "'");

            // Remove the site.
            $site->delete();

        }

        if (isset($_POST['plugin'])) {
            header('Location: ' . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $_POST['plugin'] . '/?action=removed&sys_path=' . BASE_PATH . SYS_PATH);
        } else {
            header('Location: ' . BASE_PATH . SYS_PATH . '/system/sites.php?action=removed');
        }

    } else {

        if (isset($_POST['plugin'])) {
            header('Location: ' . BASE_PATH . CONTENT_PATH . '/extensions/plugins/' . $_POST['plugin'] . '/?sys_path=' . BASE_PATH . SYS_PATH);
        } else {
            header('Location: ' . BASE_PATH . SYS_PATH . '/system/sites.php');
        }

    }

// Else throw a exception/error.
} catch (Exception $e) {

    include_once 'init.php';
    include_once '../includes/error.header.php';
    print("        <p style=\"width: 95%; margin: 0 auto; padding: 5px 0 0 0;\">" . $e->getMessage() . "</p>\n");
    include_once '../includes/footer.php';

}

?>
