<?php

/**
 * Phire Update Charsets
 *
 * @category   Phire
 * @author     Nick Sagona, III <nick@moc10media.com>
 * @copyright  Copyright (c) 2009-2011 Moc 10 Media, LLC. (http://www.moc10media.com)
 * @license    http://www.phirecms.org/LICENSE.TXT     New BSD License
 * @version    1.1.2
 */

require_once '../../bootstrap.php';

try {

    // Process any character sets that were flagged for removal.
    $rm_charsets = array();

    if (isset($_POST['rm_charsets'])) {
        $rm_charsets = $_POST['rm_charsets'];

        // Update any assets that reference the character set and delete the character set.
        if (isset($rm_charsets[0])) {
            foreach ($rm_charsets as $value) {
                $pages = new Phire_Table_Templates();
                $pages->execute("UPDATE " . DB_PREFIX . "pages SET page_charset = 4001 WHERE page_charset = '" . (string)Moc10_String::setString($value)->escape(true)->striptags() . "'");

                $sites = new Phire_Table_Sites();
                $sites->execute("UPDATE " . DB_PREFIX . "sites SET default_charset = 4001 WHERE default_charset = '" . (string)Moc10_String::setString($value)->escape(true)->striptags() . "'");

                $charset = new Phire_Table_Charsets();
                $charset->findById($value);
                $charset->delete();
            }
        }
    }

    $idAry = array();

    foreach ($_POST as $key => $value) {
        if (strpos($key, 'charset_name_') !== false) {
            $id = substr($key, (strrpos($key, '_') + 1));
            if ($id != 'new') {
                $idAry[] = $id;
            }
        }
    }

    // Update any existing character sets.
    foreach ($idAry as $value) {
        if (!in_array($value, $rm_charsets)) {
            $charset_name = $_POST['charset_name_' . $value];
            $charset = $_POST['charset_' . $value];
            if (($charset_name != '') && ($charset != '')) {
                $edit_charset = new Phire_Table_Charsets();
                $edit_charset->findById($value);
                $edit_charset->charset_name = $charset_name;
                $edit_charset->charset = $charset;
                $edit_charset->save();
            }
        }
    }

    // Add any new character set.
    if (($_POST['charset_name_new'] != '') && ($_POST['charset_new'] != '')) {
        $new_charset = new Phire_Table_Charsets(array('charset_name' => $_POST['charset_name_new'], 'charset' => $_POST['charset_new']));
        $new_charset->save();
    }

    header('Location: ' . BASE_PATH . SYS_PATH . '/system/edit-character-sets.php?action=updated');

// Else throw a exception/error.
} catch (Exception $e) {

    include_once 'init.php';
    include_once '../includes/error.header.php';
    print("        <p style=\"width: 95%; margin: 0 auto; padding: 5px 0 0 0;\">" . $e->getMessage() . "</p>\n");
    include_once '../includes/footer.php';

}

?>
